/*
 * Programmieren fuer Physiker, SS 2023, Blatt 03, Aufg. 7
 *
 * kubische Gleichung loesen
 */

#include <iostream>
#include <cmath>
using namespace std ;

// reelle dritte Wurzel berechnen, auch fuer neg. Argumente
double cubicroot (double x)
{
    if (x>0) return exp(log(x)/3.0) ;
    if (x<0) return -exp(log(-x)/3.0) ;
    return 0.0 ;
}

int main()
{
    // const double eps = 1e-5 ;

    cout << "Kubische Gleichung" << endl ;
    cout << "a x^3 + b x^2 + c x + d = 0 " << endl ;
    
    double a,b,c,d ;
    do
    {
	cout << "Koeffizienten a, b, c, d: " ;
	cin >> a >> b >> c >> d ;
    }
    while (a == 0) ;

    double p = (3*a*c - b*b)/(3*a*a) ;
    double q = 2*b*b*b/(27*a*a*a) - b*c/(3*a*a) + d/a ;

    double dis = q*q/4 + p*p*p/27 ;
    cout << "Diskriminante: " << dis << endl ;

    if (dis>0)  // naja... (dis>eps)
    {
	double d1 = cubicroot(-q/2 + sqrt(dis)) ;
	double d2 = cubicroot(-q/2 - sqrt(dis)) ;
	cout << "Genau eine einf. reelle Lsg (und zwei komplexe)" << endl ;
	cout << "Loesung: " << d1+d2-b/(3*a) << endl ;
    }
    if (dis==0)  // naja... (abs(dis)<=eps)
    {
	if (q==0)  // auch kritisch...
	    cout << "Dreifache reelle Lsg: " << -b/(3*a) << endl;
	else
	{
	    cout << "Doppelte reelle Lsg: " 
		 << cubicroot(q/2) - b/(3*a) << endl ;
	    cout << "und einf. reelle Lsg: " 
		 << cubicroot(-4*q) - b/(3*a) << endl ;
	}
    }
    if (dis<0)   // naja... (dis<-eps)
    {
	cout << "Drei versch. reelle Loesungen" << endl ;
	double h1 = acos(-q/2*sqrt(-27/(p*p*p))) ;
	double h2 = sqrt(-(4*p)/3) ;
	double pi = 4*atan(1.0) ;
        // a C++20-Compiler and #include <numbers> in the head allows 
        // double pi = std::numbers::pi ;

	cout << "Lsg 1: " << -h2*cos(h1/3 + pi/3) - b/(3*a) << endl ;
	cout << "Lsg 2: " << -h2*cos(h1/3 - pi/3) - b/(3*a) << endl ;
	cout << "Lsg 3: " << h2*cos(h1/3) - b/(3*a) << endl ;
    }
}
